Exemplo n.º 1
0
        /// <summary>
        /// 根据条件查找BF200
        /// </summary>
        /// <param name="whereSql"></param>
        /// <returns></returns>
        public IModel GetModelByWhereSql(string whereSql)
        {
            string sql =
                "select BF200Id,ModuleTreeId,Length,LeftLength,RightLength,MPanelLength,WPanelLength,MPanelNo,UVType from BF200";

            sql += whereSql;
            SqlDataReader objReader = SQLHelper.GetReader(sql);
            BF200         objModel  = null;

            if (objReader.Read())
            {
                objModel = new BF200()
                {
                    BF200Id      = Convert.ToInt32(objReader["BF200Id"]),
                    ModuleTreeId = Convert.ToInt32(objReader["ModuleTreeId"]),
                    //最好不要用=null去判断,提示类型转换错误
                    Length       = objReader["Length"].ToString().Length == 0 ? 0 : Convert.ToDecimal(objReader["Length"]),
                    LeftLength   = objReader["LeftLength"].ToString().Length == 0 ? 0 : Convert.ToDecimal(objReader["LeftLength"]),
                    RightLength  = objReader["RightLength"].ToString().Length == 0 ? 0 : Convert.ToDecimal(objReader["RightLength"]),
                    MPanelLength = objReader["MPanelLength"].ToString().Length == 0 ? 0 : Convert.ToDecimal(objReader["MPanelLength"]),
                    WPanelLength = objReader["WPanelLength"].ToString().Length == 0 ? 0 : Convert.ToDecimal(objReader["WPanelLength"]),
                    MPanelNo     = objReader["MPanelNo"].ToString().Length == 0 ? 0 : Convert.ToInt32(objReader["MPanelNo"]),
                    UVType       = objReader["UVType"].ToString().Length == 0 ? "" : objReader["UVType"].ToString()
                };
            }
            objReader.Close();
            return(objModel);
        }
Exemplo n.º 2
0
        /// <summary>
        /// 修改BF200的制图参数
        /// </summary>
        /// <param name="models"></param>
        /// <returns></returns>
        public int EditModel(IModel models)
        {
            BF200 objModel = (BF200)models;
            //编写带参数的SQL语句
            StringBuilder sqlBuilder = new StringBuilder();

            sqlBuilder.Append("Update BF200 set Length=@Length,LeftLength=@LeftLength,RightLength=@RightLength,MPanelLength=@MPanelLength,WPanelLength=@WPanelLength,");
            sqlBuilder.Append("MPanelNo=@MPanelNo,UVType=@UVType where BF200Id=@BF200Id");
            //定义参数数组
            SqlParameter[] param = new SqlParameter[]
            {
                new SqlParameter("@Length", objModel.Length),
                new SqlParameter("@LeftLength", objModel.LeftLength),
                new SqlParameter("@RightLength", objModel.RightLength),
                new SqlParameter("@MPanelLength", objModel.MPanelLength),
                new SqlParameter("@WPanelLength", objModel.WPanelLength),
                new SqlParameter("@MPanelNo", objModel.MPanelNo),
                new SqlParameter("@UVType", objModel.UVType),
                new SqlParameter("@BF200Id", objModel.BF200Id)
            };
            try
            {
                return(SQLHelper.Update(sqlBuilder.ToString(), param));
            }
            catch (SqlException ex)
            {
                throw new Exception("数据库操作出现异常:" + ex.Message);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
Exemplo n.º 3
0
        public FrmBF200(Drawing drawing, ModuleTree tree) : this()
        {
            objBF200 = (BF200)objBF200Service.GetModelByModuleTreeId(tree.ModuleTreeId.ToString());
            if (objBF200 == null)
            {
                return;
            }
            this.Text = drawing.ODPNo + " / Item: " + drawing.Item + " / Module: " + tree.Module + " - " + tree.CategoryName;
            Category objCategory = objCategoryService.GetCategoryByCategoryId(tree.CategoryId.ToString());

            pbModelImage.Image = objCategory.ModelImage.Length == 0
                ? Image.FromFile("NoPic.png")
                : (Image) new SerializeObjectToString().DeserializeObject(objCategory.ModelImage);
            FillData();
        }
Exemplo n.º 4
0
        private void btnEditData_Click(object sender, EventArgs e)
        {
            //必填项目
            if (pbModelImage.Tag.ToString().Length == 0)
            {
                return;
            }
            if (!DataValidate.IsDecimal(txtLength.Text.Trim()) || Convert.ToDecimal(txtLength.Text.Trim()) < 200m)
            {
                MessageBox.Show("请认真检查总长", "提示信息");
                txtLength.Focus();
                txtLength.SelectAll();
                return;
            }
            if (!DataValidate.IsDecimal(txtLeftLength.Text.Trim()) || Convert.ToDecimal(txtLeftLength.Text.Trim()) < 30m)
            {
                MessageBox.Show("请认真检查UL长度", "提示信息");
                txtLeftLength.Focus();
                txtLeftLength.SelectAll();
                return;
            }
            if (!DataValidate.IsDecimal(txtRightLength.Text.Trim()) || Convert.ToDecimal(txtRightLength.Text.Trim()) < 30m)
            {
                MessageBox.Show("请认真检查UR长度", "提示信息");
                txtRightLength.Focus();
                txtRightLength.SelectAll();
                return;
            }
            if (!DataValidate.IsDecimal(txtMPanelLength.Text.Trim()) || Convert.ToDecimal(txtMPanelLength.Text.Trim()) < 30m)
            {
                MessageBox.Show("请认真检查标准M型长度", "提示信息");
                txtMPanelLength.Focus();
                txtMPanelLength.SelectAll();
                return;
            }
            if (!DataValidate.IsDecimal(txtWPanelLength.Text.Trim()) || Convert.ToDecimal(txtWPanelLength.Text.Trim()) < 30m)
            {
                MessageBox.Show("请认真检查标准W型长度", "提示信息");
                txtWPanelLength.Focus();
                txtWPanelLength.SelectAll();
                return;
            }
            if (cobMPanelNo.SelectedIndex == -1)
            {
                MessageBox.Show("请选择M型水洗挡板数量", "提示信息");
                cobMPanelNo.Focus();
                return;
            }
            if (cobUVType.SelectedIndex == -1)
            {
                MessageBox.Show("请选择烟罩是否带UV", "提示信息");
                cobUVType.Focus();
                return;
            }
            //封装对象
            BF200 objBF200 = new BF200()
            {
                BF200Id = Convert.ToInt32(pbModelImage.Tag),

                Length       = Convert.ToDecimal(txtLength.Text.Trim()),
                LeftLength   = Convert.ToDecimal(txtLeftLength.Text.Trim()),
                RightLength  = Convert.ToDecimal(txtRightLength.Text.Trim()),
                MPanelLength = Convert.ToDecimal(txtMPanelLength.Text.Trim()),
                WPanelLength = Convert.ToDecimal(txtWPanelLength.Text.Trim()),

                MPanelNo = Convert.ToInt32(cobMPanelNo.Text),
                UVType   = cobUVType.Text
            };

            //提交修改
            try
            {
                if (objBF200Service.EditModel(objBF200) == 1)
                {
                    MessageBox.Show("制图数据修改成功", "提示信息");
                    this.DialogResult = DialogResult.OK;
                    this.Close();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
Exemplo n.º 5
0
        public void AutoDrawing(SldWorks swApp, ModuleTree tree, string projectPath)
        {
            //创建项目模型存放地址
            string itemPath = projectPath + @"\" + tree.Module + "-" + tree.CategoryName;

            if (!Directory.Exists(itemPath))
            {
                Directory.CreateDirectory(itemPath);
            }
            else
            {
                DialogResult result =
                    MessageBox.Show("模型文件夹" + itemPath + "存在,如果之前pack已经执行过,将不执行pack过程而是直接修改模型,如果要继续请点击YES,否请点击No中断作图", "提示信息",
                                    MessageBoxButtons.YesNo);
                if (result == DialogResult.No)
                {
                    return;
                }
            }
            //Pack的后缀
            string suffix = tree.Module + "-" + tree.ODPNo.Substring(tree.ODPNo.Length - 6);
            //判断文件是否存在,如果存在将不执行pack,如果不存在则执行pack
            //packango后需要接收打包完成的地址,参数为后缀
            string packedAssyPath = itemPath + @"\" + tree.CategoryName.ToLower() + "_" + suffix + ".sldasm";

            if (!File.Exists(packedAssyPath))
            {
                packedAssyPath = CommonFunc.PackAndGoFunc(suffix, swApp, tree.ModelPath, itemPath);
            }

            //查询参数
            BF200 item = (BF200)objBF200Service.GetModelByModuleTreeId(tree.ModuleTreeId.ToString());

            swApp.CommandInProgress = true; //告诉SolidWorks,现在是用外部程序调用命令
            int warnings = 0;
            int errors   = 0;

            suffix = "_" + suffix;//后缀
            ModelDoc2         swModel    = default(ModelDoc2);
            ModelDoc2         swSubModel = default(ModelDoc2);
            ModelDoc2         swPart     = default(ModelDoc2);
            AssemblyDoc       swAssy     = default(AssemblyDoc);
            AssemblyDoc       swSubAssy  = default(AssemblyDoc);
            Component2        swComp;
            Feature           swFeat           = default(Feature);
            object            configNames      = null;
            ModelDocExtension swModelDocExt    = default(ModelDocExtension);
            ModelDocExtension swSubModelDocExt = default(ModelDocExtension);
            bool   status      = false;
            string compReName  = string.Empty;
            string subAssyName = string.Empty;

            //打开Pack后的模型
            swModel = swApp.OpenDoc6(packedAssyPath, (int)swDocumentTypes_e.swDocASSEMBLY,
                                     (int)swOpenDocOptions_e.swOpenDocOptions_Silent, "", ref errors, ref warnings) as ModelDoc2;
            swAssy = swModel as AssemblyDoc;                                                  //装配体
            string assyName = swModel.GetTitle().Substring(0, swModel.GetTitle().Length - 7); //获取装配体名称

            swModelDocExt = (ModelDocExtension)swModel.Extension;
            //打开装配体后必须重建,使Pack后的零件名都更新到带后缀的状态,否则程序出错
            swModel.ForceRebuild3(true);
            //TopOnly参数设置成true,只重建顶层,不重建零件内部

            /*注意SolidWorks单位是m,计算是应当/1000m
             * 整形与整形运算得出的结果仍然时整形,1640 / 1000m结果为0,因此必须将其中一个转化成decimal型,使用后缀m就可以了
             * (int)不进行四舍五入,Convert.ToInt32会四舍五入
             */
            //-----------计算中间值,----------
            try
            {
                //----------Top Level----------
                swModel.Parameter("D1@Distance36").SystemValue = (item.Length - 3m) / 1000m;
                //----------M型水洗挡板----------
                if (item.MPanelNo == 0)
                {
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "BFM-1"));
                    swComp.SetSuppression2(0);                 //2解压缩,0压缩.
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "BFW-8"));
                    swComp.SetSuppression2(0);                 //2解压缩,0压缩. .
                    swFeat = swAssy.FeatureByName("LocalLPattern1");
                    swFeat.SetSuppression2(0, 2, configNames); //参数1:1解压,0压缩
                }
                else
                {
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "BFM-1"));
                    swComp.SetSuppression2(2);                                                               //2解压缩,0压缩.
                    swSubAssy        = swComp.GetModelDoc2();                                                //打开子装配
                    swSubModel       = (ModelDoc2)swSubAssy;
                    subAssyName      = swSubModel.GetTitle().Substring(0, swSubModel.GetTitle().Length - 7); //获取装配体名称
                    swSubModelDocExt = (ModelDocExtension)swSubModel.Extension;
                    //重命名装配体内部
                    compReName = "FNCE0120[BFM-" + tree.Module + "]{" + (int)item.MPanelLength + "}";
                    status     = swSubModelDocExt.SelectByID2(CommonFunc.AddSuffix(suffix, "FNCE0120[BFM-]{}-1") + "@" + subAssyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                    if (status)
                    {
                        swSubModelDocExt.RenameDocument(compReName);
                    }
                    swSubModel.ClearSelection2(true);
                    status = swSubModelDocExt.SelectByID2(compReName + "-1" + "@" + subAssyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                    swSubModel.ClearSelection2(true);
                    if (status)
                    {
                        swComp = swSubAssy.GetComponentByName(compReName + "-1");
                        swPart = swComp.GetModelDoc2(); //打开零件
                        swPart.Parameter("D1@Sketch1").SystemValue = item.MPanelLength / 1000m;
                    }

                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "BFW-8"));
                    swComp.SetSuppression2(2);         //2解压缩,0压缩.
                    swSubAssy = swComp.GetModelDoc2(); //打开子装配
                    if (item.UVType == "YES")
                    {
                        swComp = swSubAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCE0124-1"));
                        swComp.SetSuppression2(2); //2解压缩,0压缩.
                        swComp = swSubAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "2900100016-1"));
                        swComp.SetSuppression2(2); //2解压缩,0压缩.
                    }
                    else
                    {
                        swComp = swSubAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCE0124-1"));
                        swComp.SetSuppression2(0); //2解压缩,0压缩.
                        swComp = swSubAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "2900100016-1"));
                        swComp.SetSuppression2(0); //2解压缩,0压缩.
                    }
                    swFeat = swAssy.FeatureByName("LocalLPattern1");
                    swFeat.SetSuppression2(1, 2, configNames); //参数1:1解压,0压缩
                    swModel.Parameter("D1@LocalLPattern1").SystemValue = item.MPanelNo;
                    swModel.Parameter("D3@LocalLPattern1").SystemValue = (item.MPanelLength + item.WPanelLength) / 1000m;
                }
                //----------W型水洗挡板----------
                swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "BFWF-8"));
                swComp.SetSuppression2(2);                                                               //2解压缩,0压缩.
                swSubAssy        = swComp.GetModelDoc2();                                                //打开子装配
                swSubModel       = (ModelDoc2)swSubAssy;
                subAssyName      = swSubModel.GetTitle().Substring(0, swSubModel.GetTitle().Length - 7); //获取装配体名称
                swSubModelDocExt = (ModelDocExtension)swSubModel.Extension;
                if (item.UVType == "YES")
                {
                    swComp = swSubAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCE0124-1"));
                    swComp.SetSuppression2(2); //2解压缩,0压缩.
                    swComp = swSubAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "2900100016-1"));
                    swComp.SetSuppression2(2); //2解压缩,0压缩.
                }
                else
                {
                    swComp = swSubAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCE0124-1"));
                    swComp.SetSuppression2(0); //2解压缩,0压缩.
                    swComp = swSubAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "2900100016-1"));
                    swComp.SetSuppression2(0); //2解压缩,0压缩.
                }
                //重命名装配体内部
                compReName = "FNCE0121[BFW-" + tree.Module + "]{" + (int)item.WPanelLength + "}";
                status     = swSubModelDocExt.SelectByID2(CommonFunc.AddSuffix(suffix, "FNCE0121[BFW-]{}-1") + "@" + subAssyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                if (status)
                {
                    swSubModelDocExt.RenameDocument(compReName);
                }
                swSubModel.ClearSelection2(true);
                status = swSubModelDocExt.SelectByID2(compReName + "-1" + "@" + subAssyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                swSubModel.ClearSelection2(true);
                if (status)
                {
                    swComp = swSubAssy.GetComponentByName(compReName + "-1");
                    swPart = swComp.GetModelDoc2(); //打开零件
                    swPart.Parameter("D1@Sketch1").SystemValue = item.WPanelLength / 1000m;
                    swFeat = swComp.FeatureByName("Cut-Extrude8");
                    if (item.UVType == "YES")
                    {
                        swFeat.SetSuppression2(1, 2, configNames);                     //参数1:1解压,0压缩
                    }
                    else
                    {
                        swFeat.SetSuppression2(0, 2, configNames);  //参数1:1解压,0压缩
                    }
                }
                //----------UL水洗挡板----------
                swComp           = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "BFUL-1"));
                swSubAssy        = swComp.GetModelDoc2();                                                //打开子装配
                swSubModel       = (ModelDoc2)swSubAssy;
                subAssyName      = swSubModel.GetTitle().Substring(0, swSubModel.GetTitle().Length - 7); //获取装配体名称
                swSubModelDocExt = (ModelDocExtension)swSubModel.Extension;
                //重命名装配体内部
                compReName = "FNCE0119[BFUL-" + tree.Module + "]{" + (int)(item.LeftLength - 7) + "}";
                status     = swSubModelDocExt.SelectByID2(CommonFunc.AddSuffix(suffix, "FNCE0119[BFUL-]{}-1") + "@" + subAssyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                if (status)
                {
                    swSubModelDocExt.RenameDocument(compReName);
                }
                swSubModel.ClearSelection2(true);
                status = swSubModelDocExt.SelectByID2(compReName + "-1" + "@" + subAssyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                swSubModel.ClearSelection2(true);
                if (status)
                {
                    swComp = swSubAssy.GetComponentByName(compReName + "-1");
                    swPart = swComp.GetModelDoc2(); //打开零件
                    swPart.Parameter("D1@Sketch1").SystemValue = (item.LeftLength - 7m) / 1000m;
                }
                //----------UR水洗挡板----------
                swComp           = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "BFUR-1"));
                swSubAssy        = swComp.GetModelDoc2();                                                //打开子装配
                swSubModel       = (ModelDoc2)swSubAssy;
                subAssyName      = swSubModel.GetTitle().Substring(0, swSubModel.GetTitle().Length - 7); //获取装配体名称
                swSubModelDocExt = (ModelDocExtension)swSubModel.Extension;
                //重命名装配体内部
                compReName = "FNCE0118[BFUR-" + tree.Module + "]{" + (int)(item.RightLength - 7) + "}";
                status     = swSubModelDocExt.SelectByID2(CommonFunc.AddSuffix(suffix, "FNCE0118[BFUR-]{}-1") + "@" + subAssyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                if (status)
                {
                    swSubModelDocExt.RenameDocument(compReName);
                }
                swSubModel.ClearSelection2(true);
                status = swSubModelDocExt.SelectByID2(compReName + "-1" + "@" + subAssyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                swSubModel.ClearSelection2(true);
                if (status)
                {
                    swComp = swSubAssy.GetComponentByName(compReName + "-1");
                    swPart = swComp.GetModelDoc2(); //打开零件
                    swPart.Parameter("D1@Sketch1").SystemValue = (item.RightLength - 7m) / 1000m;
                }

                swModel.ForceRebuild3(true);    //设置成true,直接更新顶层,速度很快,设置成false,每个零件都会更新,很慢
                swModel.Save();                 //保存,很耗时间
                swApp.CloseDoc(packedAssyPath); //关闭,很快
            }
            catch (Exception ex)
            {
                throw new Exception(packedAssyPath + "作图过程发生异常,详细:" + ex.Message);
            }
            finally
            {
                swApp.CommandInProgress = false; //及时关闭外部命令调用,否则影响SolidWorks的使用
            }
        }